package web;

import javax.jws.WebMethod;
import javax.jws.Oneway;
import javax.jws.WebService;
import javax.jws.WebParam;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.utils.Options;

import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

import entrepot.Produit;

@WebService
public class EntrepotUnidir {

    public String testerDisponibilite (Produit pdt) {

           String res ;
	   // petit stock : 2 produits seulement !
	   Produit v = new Produit ();
	   Produit a = new Produit ();
	   v.setRef("verres");
	   v.setQuantite(200) ;
	   a.setRef("assiettes");
	   a.setQuantite(789);
	   res = "Le produit " + pdt.getRef() +
                      ", en quantit " + pdt.getQuantite() ;
           if ((v.getRef().equals (pdt.getRef()) && v.getQuantite() >= pdt.getQuantite()) ||
	       (a.getRef().equals (pdt.getRef()) && a.getQuantite() >= pdt.getQuantite())) {
                      res = res + ", est disponible.";
	   } else {
                       res = res + ", est indisponible" ;
	   } 
	   return res ;
    }

    public void envoyerDisponibilite (String reponse, String urlDest) {
	try {
            Service  service = new Service();
            Call     call    = (Call) service.createCall();


            call.setTargetEndpointAddress( new java.net.URL(urlDest) );
            call.setOperationName( new QName("PerfectGlassUnidirService", "recevoirDisponibilite") );
            call.addParameter( "reponse", XMLType.XSD_STRING, ParameterMode.IN);
            call.addParameter( "expediteur", XMLType.XSD_STRING, ParameterMode.IN);
            call.setReturnType( org.apache.axis.encoding.XMLType.XSD_STRING );

            String ret = (String) call.invoke( new Object[] {reponse, "Entrepot"} );
	} catch (Exception e) {
	   
       }
   }
	    

//         recevoirqDemandee (Produit, URL)
//            /* rponse  renvoyer  URL */

   @WebMethod
   @Oneway
       public void recevoirqDemandee (@WebParam Produit pdt, @WebParam String urlDemandeur) {
       try {
	   String rep ;
	   rep = testerDisponibilite(pdt) ;
	   envoyerDisponibilite (rep, urlDemandeur);

       } catch (Exception e) {

       } 
   }


}
